#define APPNAME  "test - TextureRect"
#define APPTITLE "test - 9.0C Pixel Shader ⺻ ~~  ѷ ڲٿ.."

#define _RELEASE_(p) { if(p) { (p)->Release(); (p)=NULL; };}
#define _DELETE_(p)  { if(p) { delete (p);     (p)=NULL; };}

#include <windows.h>
#include <time.h>

#include <d3d9.h>
#include <d3dx9.h>
#pragma comment (lib, "dxguid.lib")
#pragma comment (lib, "d3d9.lib")
#pragma comment (lib, "d3dx9.lib")


//ؽ ü Ÿ 
typedef struct MYVERTEX
{
	float	   x;
	float	   y;
	float	   z;
	D3DCOLOR   color; 
	float      u;
	float      v;
} MYVERTEX, *LPMYVERTEX;

#define D3DFVF_MYVERTEX (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1)


bool g_bIsFullScreen = false;	    // is our app Full screen or not
int g_iScreenX = 640, g_iScreenY = 480;	// use this if 'not'
D3DDISPLAYMODE  g_d3ddm = {640, 480, 60, D3DFMT_R5G6B5};


BOOL	g_bActive = TRUE;
HWND	g_hWnd = NULL;


LPDIRECT3D9             g_d3d        = NULL; // our main d3d8 interface
LPDIRECT3DDEVICE9       g_pd3dDevice = NULL; // our d3d8 device
LPDIRECT3DVERTEXBUFFER9 g_pVertexBuffer = NULL; // our VertexBuffer
LPDIRECT3DTEXTURE9      g_pTexture   = NULL;

D3DPRESENT_PARAMETERS	g_d3dpp; 


LPDIRECT3DPIXELSHADER9  g_hPShader = 0;  //ȼ ̴ ڵ 


LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
HRESULT CreateShader();


bool WindowInit(HINSTANCE hInst, int nCmdShow);
bool AppInit(HINSTANCE hInst, int nCmdShow);
HRESULT InitD3D(HWND hWnd);
void SetupCamera();
bool RenderInit();
void DestroyDirect3D8();
HRESULT ResetDeviceObjects();
HRESULT RenderLoop();
HRESULT Render3D();
void	DestroyDirect3D8();


//-----------------------------------------------------------------------------
LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_ACTIVATE:
		g_bActive = LOWORD(wParam);
		return 0;
		break;

	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
		{
			DestroyDirect3D8();
			DestroyWindow(hWnd);
			PostQuitMessage(0);
		}
		break;

	case WM_CLOSE:          
		DestroyDirect3D8();
        DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	case WM_SYSCOMMAND:
		// Prevent moving/sizing and power loss in fullscreen mode
		switch( wParam )
		{
			case SC_MOVE:
			case SC_SIZE:
			case SC_MAXIMIZE:
			case SC_KEYMENU:
			case SC_MONITORPOWER:
				if( g_bIsFullScreen)
					return 1;
				break;
		}
		break;

    case WM_NCHITTEST:
       // Prevent the user from selecting the menu in fullscreen mode
        if(g_bIsFullScreen)
              return HTCLIENT;
        break;
/*  콺 Ŀ ʿ   Ѵ
	case WM_SETCURSOR:
		SetCursor (NULL);
		return 0;
		break; 
*/
	};
	return DefWindowProc(hWnd, message, wParam, lParam);
}
//-----------------------------------------------------------------------------
bool WindowInit(HINSTANCE hInst, int nCmdShow)
{
	WNDCLASS		    wcl;
		
	wcl.hInstance		= hInst;
	wcl.lpszClassName	= APPNAME;
	wcl.lpfnWndProc		= WindowProc;
	wcl.style			= 0;

	wcl.hIcon			= LoadIcon (NULL, IDC_ICON);
	wcl.hCursor			= LoadCursor (NULL, IDC_ARROW);
	wcl.lpszMenuName	= NULL;

	wcl.cbClsExtra		= 0;
	wcl.cbWndExtra		= 0;
	wcl.hbrBackground	= (HBRUSH) GetStockObject (BLACK_BRUSH);

	RegisterClass (&wcl);

	if(g_bIsFullScreen)
	{
		g_hWnd = CreateWindowEx (
			NULL,
			APPNAME,
			APPTITLE,
			WS_POPUP|WS_SYSMENU|WS_VISIBLE, 
			0, 0, 
			g_d3ddm.Width,
			g_d3ddm.Height,
			NULL,
			NULL,
			hInst,
			NULL);
	}
	else
	{
		int sx = GetSystemMetrics (SM_CXSCREEN);
		int sy = GetSystemMetrics (SM_CYSCREEN);

		g_hWnd = CreateWindowEx (
			NULL,
			APPNAME,
			APPTITLE,
			WS_OVERLAPPED | WS_SYSMENU,
			sx/2 - g_iScreenX/2, sy/2 - g_iScreenY/2,
			g_iScreenX,
			g_iScreenY,
			NULL,
			NULL,
			hInst,
			NULL);
	};

	if(!g_hWnd) 
		return false;

	return true;
}
//-----------------------------------------------------------------------------
bool AppInit(HINSTANCE hInst, int nCmdShow)
{
	srand (time(0)); // randomize timer

	if(!WindowInit (hInst, nCmdShow)) 
		return false;

	ShowWindow (g_hWnd, nCmdShow);
	UpdateWindow (g_hWnd);
    
	return true;
}
//-----------------------------------------------------------------------------
HRESULT InitD3D(HWND hWnd)
{
	ZeroMemory (&g_d3dpp, sizeof(g_d3dpp));

    if( NULL == ( g_d3d = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;

	if(g_bIsFullScreen)
	{
		g_d3dpp.BackBufferWidth = g_d3ddm.Width;
		g_d3dpp.BackBufferHeight = g_d3ddm.Height;
		g_d3dpp.BackBufferCount = 1;
		g_d3dpp.FullScreen_RefreshRateInHz = g_d3ddm.RefreshRate; //D3DPRESENT_RATE_DEFAULT
		g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_ONE;
	}
	else
	{
		if( FAILED( g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &g_d3ddm)))
			return E_FAIL;
	}

    g_d3dpp.Windowed = !g_bIsFullScreen;
    g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    g_d3dpp.BackBufferFormat = g_d3ddm.Format;

	g_d3dpp.EnableAutoDepthStencil	= TRUE; 
	g_d3dpp.AutoDepthStencilFormat	= D3DFMT_D16;

    if(FAILED(g_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
								   D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
								   &g_d3dpp, &g_pd3dDevice)))
	{
		g_d3dpp.AutoDepthStencilFormat	= D3DFMT_D32;
		if(FAILED(g_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
								   D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
								   &g_d3dpp, &g_pd3dDevice)))
			return E_FAIL;
	}

	g_pd3dDevice->SetRenderState( D3DRS_ZENABLE, TRUE );
	g_pd3dDevice->SetRenderState( D3DRS_AMBIENT, 0xffffffff );
	g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE );
	return S_OK;
}
//-----------------------------------------------------------------------------
void SetupCamera()
{
    D3DXMATRIX   matProj;
	D3DXMATRIX	 matCameraView;
	D3DXVECTOR3  cameraTarget;
    D3DXVECTOR3  cameraPos;

	// Set where camera is viewing from
	cameraPos.x = 0.0f;
	cameraPos.y = 0.0f;
	cameraPos.z = -10.0f;
	// Set what camera is looking at
	cameraTarget.x = 0.0f;
	cameraTarget.y = 0.0f;
	cameraTarget.z = 0.0f;

	// Setup Camera View
	D3DXMatrixLookAtLH( &matCameraView, 
						&cameraPos, 
						&cameraTarget, 
						&D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );
	// Tell the device to use the camera view for the viewport
	g_pd3dDevice->SetTransform( D3DTS_VIEW, &matCameraView );

	// Setup Projection 
	D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 100.0f );
	// Tell the device to use the above matrix for projection
	g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );
}
//-----------------------------------------------------------------------------
bool RenderInit()
{
	void	*lpVertices;
	float	fSizeX = 5.0f;
	float	fSizeY = 5.0f;
	
	MYVERTEX	vertex[4];

	// Create the geometry
	vertex[0].x = -fSizeX/2;
	vertex[0].y = -fSizeY/2;
	vertex[0].z = 0.0f;
	vertex[0].color = 0xffffff;
	vertex[0].u = 0.0f;
    vertex[0].v = 1.0f;
	
	vertex[1].x = -fSizeX/2;
	vertex[1].y = fSizeY/2;
	vertex[1].z = 0.0f;
	vertex[1].color = 0xffffff;
	vertex[1].u = 0.0f;
    vertex[1].v = 0.0f;

	vertex[2].x = fSizeX/2;
	vertex[2].y = -fSizeY/2;
	vertex[2].z = 0.0f;
	vertex[2].color = 0xffffff;
	vertex[2].u = 1.0f;
    vertex[2].v = 1.0f;
	
	vertex[3].x = fSizeX/2;
	vertex[3].y = fSizeY/2;
	vertex[3].z = 0.0f;
	vertex[3].color = 0xffffff;
	vertex[3].u = 1.0f;
    vertex[3].v = 0.0f;
	
	// Create the vertex buffer
	if(FAILED(g_pd3dDevice->CreateVertexBuffer(4*sizeof(MYVERTEX), 
		                   0, D3DFVF_MYVERTEX, D3DPOOL_DEFAULT, &g_pVertexBuffer, NULL)))
	{
		return false;
	}
	// Lock the buffer
	if(FAILED(g_pVertexBuffer->Lock(0, sizeof(vertex), &lpVertices, 0))) 
	{
		return false;
	}

	memcpy(lpVertices, vertex, sizeof(vertex));
	g_pVertexBuffer->Unlock();

    if( FAILED( D3DXCreateTextureFromFile( g_pd3dDevice, "grim.jpg", &g_pTexture ) ) ) 
			return false;

	return true;
}
//-----------------------------------------------------------------------------
void DestroyDirect3D8()
{
	_RELEASE_(g_hPShader);

	_RELEASE_ (g_pTexture);
	_RELEASE_ (g_pVertexBuffer);
	_RELEASE_ (g_pd3dDevice);
	_RELEASE_ (g_d3d);
}
//-----------------------------------------------------------------------------
HRESULT ResetDeviceObjects()
{
	HRESULT hr;

    // Release all vidmem objects
    //if( FAILED( hr = InvalidateDeviceObjects() ) )
    //    return hr;

	// Reset the device
	if( FAILED( hr = g_pd3dDevice->Reset( &g_d3dpp ) ) )
		return hr;

	return S_OK;
}
//-----------------------------------------------------------------------------
HRESULT RenderLoop()
{
    HRESULT hr;

    // Test the cooperative level to see if it's okay to render
    if( FAILED( hr = g_pd3dDevice->TestCooperativeLevel() ) )
    {
        // If the device was lost, do not render until we get it back
        if( D3DERR_DEVICELOST == hr )
            return S_OK;

        // Check if the device needs to be resized.
        if( D3DERR_DEVICENOTRESET == hr )
        {
            // If we are windowed, read the desktop mode and use the same format for
            // the back buffer
            if( !g_bIsFullScreen )
            {
				g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &g_d3ddm);
                g_d3dpp.BackBufferFormat = g_d3ddm.Format;
            }

            if( FAILED( hr = ResetDeviceObjects() ) )
                return hr;
        }
        return hr;
    }

    // Render the scene as normal
    if( FAILED( hr = Render3D() ) )
        return hr;

	return S_OK;
}
//-----------------------------------------------------------------------------
HRESULT Render3D ()
{
	HRESULT hr;

	D3DXMATRIX	matTranslation;

	// Clear the scene
	g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,
		                                D3DCOLOR_XRGB(150,150,255), 1.0f, 0 );
	g_pd3dDevice->BeginScene();

	D3DXMatrixIdentity( &matTranslation );
	g_pd3dDevice->SetTransform(D3DTS_WORLD, &matTranslation);
	
	//Set texture
	g_pd3dDevice->SetTexture( 0, g_pTexture );

	g_pd3dDevice->SetStreamSource(0, g_pVertexBuffer, 0, sizeof(MYVERTEX));
	g_pd3dDevice->SetFVF(D3DFVF_MYVERTEX);

	float fColorConstant[][4] = 
	{
        { 0.3333f, 0.59f, 0.11f, 0.0f}
    };
    g_pd3dDevice->SetPixelShaderConstantF( 2, (float*)fColorConstant ,1); 
	g_pd3dDevice->SetPixelShader(g_hPShader);

	g_pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);

    //Clear texture
	g_pd3dDevice->SetTexture( 0, NULL );
	
	g_pd3dDevice->EndScene();
	hr = g_pd3dDevice->Present( NULL, NULL, NULL, NULL );

	return hr;
}
//-----------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	if(!AppInit(hInst, nCmdShow)) 
		return -1;
	if(InitD3D(g_hWnd)!= S_OK )
		return -1;
	
	SetupCamera();

	if(FAILED(CreateShader()))
		return -1;

	if(!RenderInit())
		return -1;

	BOOL bGotMsg;

	msg.message = WM_NULL;
	PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );
    while( WM_QUIT != msg.message  )
    {
        // Use PeekMessage() if the app is active, so we can use idle time to
        // render the scene. Else, use GetMessage() to avoid eating CPU time.
        if( g_bActive )
            bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );
        else
            bGotMsg = GetMessage( &msg, NULL, 0U, 0U );

        if( bGotMsg )
        {
            // Translate and dispatch the message
            //if( 0 == TranslateAccelerator( g_hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
        }
        else
        {
            // Render a frame during idle time (no messages are waiting)
            if( g_bActive )//&& m_bReady )
            {
                if( FAILED( RenderLoop()))
                    SendMessage( g_hWnd, WM_CLOSE, 0, 0 );
            }
        }
    }

	UnregisterClass( APPNAME, hInst);
	return 0;
}
//-----------------------------------------------------------------------------
HRESULT CreateShader()
{
	const char szPixelShader[] =
	"ps.1.1							        \n"
	//"def c2, 0.3333f, 0.59f, 0.11f, 0.0f  \n"
	"tex t0									\n"
	"dp3 r0, t0, c2							\n";
 
	ID3DXBuffer* pShaderBuffer;
	ID3DXBuffer* pShaderErrors;
	if (FAILED(D3DXAssembleShader(szPixelShader, sizeof(szPixelShader) - 1, 0, NULL,
										D3DXSHADER_DEBUG, &pShaderBuffer, &pShaderErrors)))
		return E_FAIL;

	if (FAILED(g_pd3dDevice->CreatePixelShader((DWORD *)pShaderBuffer->GetBufferPointer(), &g_hPShader)))
		return E_FAIL;
	_RELEASE_(pShaderBuffer);
	return S_OK;
}	
